"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _ = require('underscore');
var checkTypes = require('check-types');
exports.DEFAULT_ARG = 'DEFAULT';
var Arguments = (function () {
    function Arguments() {
    }
    Arguments.prototype.toArgumentsArray = function (args, mappings) {
        var _this = this;
        return _.chain(args instanceof Array ? args : [args])
            .map(function (x) { return _this.createArgumentsFromObject(x, mappings); })
            .flatten()
            .value();
    };
    Arguments.prototype.createArgumentsFromObject = function (args, mappings) {
        return _.chain(args)
            .reduce(function (acc, value, key) {
            if (value && mappings[key]) {
                var mapping_1 = mappings[key];
                var f_1 = acc.push.bind(acc);
                if (mapping_1 === exports.DEFAULT_ARG) {
                    mapping_1 = '';
                    f_1 = acc.unshift.bind(acc);
                }
                _.map(checkTypes.array(value) ? value : [value], function (v) {
                    return f_1([mapping_1, "'" + v + "'"]);
                });
            }
            return acc;
        }, [])
            .flatten()
            .compact()
            .value();
    };
    return Arguments;
}());
exports.Arguments = Arguments;
exports.default = new Arguments();
//# sourceMappingURL=arguments.js.map